unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ImgList, ComCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Timer2: TTimer;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Timer3: TTimer;
    Image1: TImage;
    CheckBox3: TCheckBox;
    Label5: TLabel;
    TrackBar1: TTrackBar;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Timer4: TTimer;
    Label10: TLabel;
    Label11: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CheckBox3Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Timer4Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  CommThread : THandle;
  CommHandle : integer;
  Ovr : TOverlapped;
  Stat : TComStat;
  DCB : TDCB;
  cb,Mask,TransMask,Errs : DWord;
  str1,str2:string[120];
  str3,str4:string;
  posx,flcom,f1,f2,maxval,spd,ang:integer;
const
  ovf=-2;err=-1;num=0;txt=1;tok=2;

implementation

{$R *.dfm}

function ReadComm:integer;
var i,s,a,c,ftm:integer;
begin
i:=1;c:=0;ftm:=num;
while true do begin
  c:=c+1;if c>40 then begin readcomm:=err;exit;end;
  WaitCommEvent(CommHandle,TransMask,@Ovr);
  ClearCommError(CommHandle,Errs,@Stat);
  if stat.cbInQue<>0 then begin
    ReadFile(CommHandle,str1[i],1,cb,@Ovr);
    if str1[i]=chr($0d) then begin
      str1[i]:=chr(0);setlength(str1,i-1);
      if str1='OK' then ftm:=tok;
      if str1='ER' then ftm:=err;
      readcomm:=ftm;exit;
    end;
    if (str1[i]<'0')or(str1[i]>'9') then ftm:=txt;
    i:=i+1;
    if i>50 then begin readcomm:=ovf;exit;end;
  end else sleep(1);
end;
end;

function PortOpen:integer;
var ThreadID:dword;
begin
  if flcom=255 then begin
    form1.Timer1.Enabled:=false;
    CloseHandle(CommHandle);
    flcom:=0;
  end else begin
//    CommHandle:=CreateFile(PAnsiChar(PChar(ComboBox1.Items.ValueFromIndex[ComboBox1.ItemIndex])),GENERIC_READ or GENERIC_WRITE,0,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL or FILE_FLAG_OVERLAPPED,0);
    CommHandle:=CreateFile(PAnsiChar(PChar(str3)),GENERIC_READ or GENERIC_WRITE,0,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL or FILE_FLAG_OVERLAPPED,0);
    if CommHandle = INVALID_HANDLE_VALUE then begin raise Exception.Create('Error opening port');portopen:=-1;exit;end;
    SetCommMask(CommHandle,EV_RXCHAR);
    GetCommState(CommHandle,DCB);
    DCB.BaudRate:=CBR_9600;
    DCB.Parity:=NOPARITY;
    DCB.ByteSize:=8;
    DCB.StopBits:=OneStopBit;
    SetCommState(CommHandle,DCB);
    if not PurgeComm(CommHandle,PURGE_TXCLEAR or PURGE_RXCLEAR) then begin ShowMessage('Error purging port');portopen:=-1;exit;end;
    flcom:=255;
    portopen:=0;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
flcom:=0;
f1:=0;
memo1.Lines.LoadFromFile('rcinit.txt');
str3:=memo1.Lines.Strings[0];
portopen;
image1.Canvas.Brush.Color:=clBtnFace;
image1.Canvas.Rectangle(0,0,16,16);
image1.Canvas.Brush.Color:=clRed;
image1.Canvas.Ellipse(3,3,13,13);
spd:=0;
ang:=90;
str2:='; STOP ; MOTOR ENABLE ; SERVO ENABLE ; PORT DDR $FF ; ADC IREF ;';
WriteFile(CommHandle,str2[1],length(str2),cb,@Ovr);
if readcomm<>tok then exit;
if readcomm<>tok then exit;
if readcomm<>tok then exit;
if readcomm<>tok then exit;
if readcomm<>tok then exit;
image1.Canvas.Brush.Color:=clGreen;
image1.Canvas.Ellipse(3,3,13,13);
//windows.DestroyWindow(Form1.Handle);
form1.Timer1.Enabled:=true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
Label3.Caption:=inttostr(spd);
Label4.Caption:=inttostr(ang);
image1.Canvas.Ellipse(3,3,13,13);
str2:='; AT ;';
WriteFile(CommHandle,str2[1],length(str2),cb,@Ovr);
if readcomm<>tok then image1.Canvas.Brush.Color:=clRed else
image1.Canvas.Brush.Color:=clGreen;
image1.Canvas.Ellipse(3,3,13,13);
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  if spd>0 then spd:=spd-1;
  if spd<0 then spd:=spd+1;
  if spd=0 then Timer2.Enabled:=false;
  str2:=' MOTOR ML '+inttostr(spd)+' ;';
  WriteFile(CommHandle,str2[1],length(str2),cb,@Ovr);
  if readcomm<>tok then exit;
end;

procedure TForm1.Timer3Timer(Sender: TObject);
begin
  if ang>93 then ang:=ang-4;
  if ang<87 then ang:=ang+4;
  if (ang<91)and(ang>89) then Timer3.Enabled:=false;
  str2:=' SERVO 0 '+inttostr(ang)+' ;';
  WriteFile(CommHandle,str2[1],length(str2),cb,@Ovr);
  if readcomm<>tok then exit;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
spd:=spd+1;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
spd:=spd-1;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
ang:=ang+15;if ang>170 then ang:=170;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
ang:=ang-15;if ang<10 then ang:=10;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if GetAsyncKeyState($57)<>0 then begin
spd:=spd+1;if spd>8 then spd:=8;
Timer2.Enabled:=CheckBox1.Checked;
str2:=' MOTOR ML '+inttostr(spd)+' ;';
WriteFile(CommHandle,str2[1],length(str2),cb,@Ovr);
if readcomm<>tok then exit;
end;
if GetAsyncKeyState($53)<>0 then begin
spd:=spd-1;if spd<-8 then spd:=-8;
Timer2.Enabled:=CheckBox1.Checked;
str2:=' MOTOR ML '+inttostr(spd)+' ;';
WriteFile(CommHandle,str2[1],length(str2),cb,@Ovr);
if readcomm<>tok then exit;
end;
if GetAsyncKeyState($44)<>0 then begin
ang:=ang-15;if ang<10 then ang:=10;
Timer3.Enabled:=CheckBox2.Checked;
str2:=' SERVO 0 '+inttostr(ang)+' ;';
WriteFile(CommHandle,str2[1],length(str2),cb,@Ovr);
if readcomm<>tok then exit;
end;
if GetAsyncKeyState($41)<>0 then begin
ang:=ang+15;if ang>170 then ang:=170;
Timer3.Enabled:=CheckBox2.Checked;
str2:=' SERVO 0 '+inttostr(ang)+' ;';
WriteFile(CommHandle,str2[1],length(str2),cb,@Ovr);
if readcomm<>tok then exit;
end;

end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
if checkbox3.Checked then begin
  str2:=' PORT 1 ;';
  WriteFile(CommHandle,str2[1],length(str2),cb,@Ovr);
  if readcomm<>tok then exit;end else begin
  str2:=' PORT 0 ;';
  WriteFile(CommHandle,str2[1],length(str2),cb,@Ovr);
  if readcomm<>tok then exit;end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
if trackBar1.Position=1 then begin
str2:=' SERVO 2 90 ;';
  WriteFile(CommHandle,str2[1],length(str2),cb,@Ovr);
  if readcomm<>tok then exit;
end;
if trackBar1.Position=2 then begin
str2:=' SERVO 2 20 ;';
  WriteFile(CommHandle,str2[1],length(str2),cb,@Ovr);
  if readcomm<>tok then exit;
end;
if trackBar1.Position=0 then begin
str2:=' SERVO 2 135 ;';
  WriteFile(CommHandle,str2[1],length(str2),cb,@Ovr);
  if readcomm<>tok then exit;
end;
end;

procedure TForm1.Timer4Timer(Sender: TObject);
var a:integer;u:real;
begin
str2:=' ADC 7 6 ;';
WriteFile(CommHandle,str2[1],length(str2),cb,@Ovr);
sleep(5);
if readcomm=num then begin
  a:=strtoint(str1);
  u:=2.56*a/500;
  if u<3.0 then Label5.Color:=clYellow else Label5.Color:=clBtnFace;
  Label5.Caption:=FormatFloat('0.0',u);
end;
sleep(5);
if readcomm=num then begin
  a:=strtoint(str1);
  u:=2.56*a/180;
  if u<6.0 then Label9.Color:=clYellow else Label9.Color:=clBtnFace;
  Label9.Caption:=FormatFloat('0.0',u);
end;
end;

end.
